
#pragma once


#include "MediaDecoder.h"

#include "FileReader.h"
#include "TsPacketParser.h"
#include "TsDescrambler.h"
#include "ProgManager.h"
#include "TsDemuxer.h"
#include "FileWriter.h"

#include "AacConverter.h"
#include "WaveWriter.h"


class CTsConverter : protected CDecoderHandler
{
public:
	// CxgnhC^tF[X
	class IEventHandler
	{
	public:
		virtual void OnTsConverterStart(const ULONGLONG llFileSize) = 0;
		virtual void OnTsConverterEnd(const ULONGLONG llFileSize) = 0;
		virtual void OnTsConverterProgress(const ULONGLONG llCurPos, const ULONGLONG llFileSize) = 0;
		virtual void OnTsConverterServiceName(LPCTSTR lpszServiceName) = 0;
	};

	CTsConverter(IEventHandler *pEventHandler);
	~CTsConverter(void);

	const bool ConvertTsFile(LPCTSTR lpszTsFile, LPCTSTR lpszVideoFile, LPCTSTR lpszAudioFile, const bool bDecodeAac = false, const bool bLipSync = false, const BYTE byChannel = 2);
	void CancelConvert(void);

protected:
	void CloseDecoders(void);
	virtual const DWORD OnDecoderEvent(CMediaDecoder *pDecoder, const DWORD dwEventID, PVOID pParam);

	// IMediaDecoder hfBAfR[_NX
	CFileReader m_FileReader;			// t@C[_
	CTsPacketParser m_TsPacketParser;	// TSpPb^CU
	CTsDescrambler m_TsDescrambler;		// TSfXNu
	CProgManager m_ProgManager;			// TSvO}l[W
	CTsDemuxer m_TsDemuxer;				// TSf}NT
	CFileWriter m_VideoFile;			// rfIt@C
	CFileWriter m_AudioFile;			// rfIt@C
	CAacConverter m_AacConverter;		// AACfR[_
	CWaveWriter m_WaveWriter;			// WaveC^

	IEventHandler *m_pEventHandler;
};
